Index: src/backend/utils/error/elog.c
===================================================================
RCS file: /repositories/postgreshome/cvs/pgsql/src/backend/utils/error/elog.c,v
retrieving revision 1.226
diff -c -p -r1.226 elog.c
*** src/backend/utils/error/elog.c	19 Aug 2010 22:55:01 -0000	1.226
--- src/backend/utils/error/elog.c	1 Apr 2011 14:08:38 -0000
*************** write_stderr(const char *fmt,...)
*** 2759,2766 ****
  	}
  	else
  	{
! 		/* Not running as service, write to stderr */
! 		write_console(errbuf, strlen(errbuf));
  		fflush(stderr);
  	}
  #endif
--- 2759,2773 ----
  	}
  	else
  	{
! 		/* 
! 		 * To use the write_console we need memoryContext as its using palloc
! 		 * internally. When we don't have CurrentMemoryContext directly throw
! 		 * error at stderr.
! 		 */
! 		if (CurrentMemoryContext)
! 			write_console(errbuf, strlen(errbuf));
! 		else
! 			vfprintf(stderr, fmt, ap);
  		fflush(stderr);
  	}
  #endif
